## pandas 1.0.5+dfsg

=== debian/changelog ===
pandas (1.0.5+dfsg-3) unstable; urgency=medium

  * Remove pytest-asyncio test-depends.
  * Remove numba test-depends on non-x86: at least s390x crashes.

 -- Rebecca N. Palmer <rebecca_palmer@zoho.com>  Wed, 26 Aug 2020 22:34:50 +0100

pandas (1.0.5+dfsg-2) unstable; urgency=medium

  * Fix missing import and update numba submodule name in patches.
  * Disable asyncio tests (workaround for #969050).
  * Warn that numba may give wrong answers on non-x86,
    and remove test-depends on mipsel.
  * Skip a crashing test on s390x.

 -- Rebecca N. Palmer <rebecca_palmer@zoho.com>  Wed, 26 Aug 2020 20:19:16 +0100

pandas (1.0.5+dfsg-1) unstable; urgency=medium

  * Upstream bugfix release.  Refresh patches, contributors_list.
  * Fix invalid test xfails.
  * Only Recommend numba on amd64, to reduce the risk of bugs.
  * Don't test-depend on numba on ppc64el (where it crashes, #863511?)
    or on ports architectures (where it mostly isn't available).
  * Remove no longer needed test xfails/skips.
  * Upload to unstable.  (Closes: #950430)

 -- Rebecca N. Palmer <rebecca_palmer@zoho.com>  Tue, 25 Aug 2020 20:07:50 +0100

pandas (0.25.3+dfsg2-5) unstable; urgency=medium

  * Tests: ignore rounding difference on i386.  (Closes: #968208)

 -- Rebecca N. Palmer <rebecca_palmer@zoho.com>  Sun, 16 Aug 2020 20:09:14 +0100

pandas (0.25.3+dfsg2-4) unstable; urgency=medium

  * Be compatible with matplotlib 3.3.  (Closes: #966393)
  * Docs: fix broken remote->local Javascript replacement.

 -- Rebecca N. Palmer <rebecca_palmer@zoho.com>  Sun, 09 Aug 2020 22:11:25 +0100

pandas (0.25.3+dfsg2-3) unstable; urgency=medium

  * Nested DataFrames may raise ValueError with numpy 1.19
    (upstream bug 32289).  Clarify error message and xfail tests.
  * Stop using a no-longer-existing numpy constant.
  * Tests: ignore deprecations/rewordings and avoid setup exception
    with numpy 1.19.  (Together, the above Closes: #963817)
  * Bump debhelper compat to 13.
  * Fix HDFStore.flush (part of #877419) on s390x.
  * Add NEWS.html.gz for Standards-Version 4.5.0.
    (Choosing not to also add NEWS.gz as it would be large.)
  * Tests: accept Hurd's errno and lack of multiprocessing.
  * Docs: replace embedded Javascript copies with links.

 -- Rebecca N. Palmer <rebecca_palmer@zoho.com>  Sun, 28 Jun 2020 21:47:22 +0100

pandas (1.0.4+dfsg-1) experimental; urgency=medium

  * Upstream bugfix release.  (Closes: #962335)
  * Refresh patches, update contributors_list.
  * Fix broken tests.
  * Tests: allow numba to raise an error on 32 bit systems.
  * Don't test-depend on numba on armel (where it crashes,
    possibly #863508) or ppc64/riscv64 (where it isn't available).
  * Xfail some more HDF5 tests on big-endian architectures.

 -- Rebecca N. Palmer <rebecca_palmer@zoho.com>  Tue, 09 Jun 2020 22:19:23 +0100

pandas (0.25.3+dfsg2-2) unstable; urgency=medium

  * Tests: don't fail on jedi deprecation warnings.

 -- Rebecca N. Palmer <rebecca_palmer@zoho.com>  Thu, 07 May 2020 11:57:06 +0100

pandas (1.0.3+dfsg2-1) experimental; urgency=medium

  * Upstream bugfix release, update contributors_list.
  * Merge packaging from unstable,
    but omit no longer needed clipboard warn/xfail.
  * Only show the NaN -> datetime warning from float dtypes
    (to avoid an exception while trying to check).
  * Recommend numba, as we now have a recent enough version.
  * Re-add dask test-dependency.
  * Clarify non-x86 warnings, remove no longer needed xfails / ignores.
  * Clean up whitespace and patch names/descriptions.
  * Remove patches no longer needed.
  * Network tests: use more stable URLs.

 -- Rebecca N. Palmer <rebecca_palmer@zoho.com>  Wed, 06 May 2020 17:07:44 +0100

pandas (0.25.3+dfsg2-1) unstable; urgency=medium

  * Remove inconveniently licensed (CC-BY-SA) snippets.
  * Fix (harmless) SyntaxWarning on install.  (Closes: #956021)
  * Fix NaT sort order and test failures with numpy 1.18.
    (Closes: #958531)

 -- Rebecca N. Palmer <rebecca_palmer@zoho.com>  Wed, 06 May 2020 12:18:23 +0100

pandas (0.25.3+dfsg-9) unstable; urgency=medium

  * Don't raise on import without matplotlib installed.  Add test of this.

 -- Rebecca N. Palmer <rebecca_palmer@zoho.com>  Fri, 03 Apr 2020 21:56:02 +0100

pandas (0.25.3+dfsg-8) unstable; urgency=medium

  * Tests: don't fail on harmless changes in dependencies.  (Closes: #954647)

 -- Rebecca N. Palmer <rebecca_palmer@zoho.com>  Thu, 02 Apr 2020 18:53:32 +0100

pandas (1.0.1+dfsg-1) experimental; urgency=medium

  * Upstream bugfix release.
  * Refresh patches.
  * Update and sort d/copyright, update contributors_list.
  * Re-enable checking the test suite.
  * Declare transition Breaks (see #950430).
  * Add jinja2 recommends/test-depends.
  * Fix test_to_numpy failure on big-endian systems.
  * Register documentation in doc-base.  (Closes: #879226)
  * Remove no longer needed test xfails/skips,
    and reorganize the remaining ones.
  * Tell I/O tests where to find the source tree's test data
    instead of skipping them.
  * Enable multiarch.
  * Temporarily drop dask test-dependency to avoid uninstallability.
  * Add warnings for the known non-x86 breakages
    (NaN -> datetime #877754, HDF and Stata I/O #877419).

 -- Rebecca N. Palmer <rebecca_palmer@zoho.com>  Sun, 23 Feb 2020 17:13:08 +0000

pandas (1.0.0+dfsg-1) experimental; urgency=medium

  * New upstream release.
  * Upload to experimental, as this is an API break (see #950430).
  * Drop patches applied upstream, refresh others.
  * Update and improve d/copyright, update contributors_list.
  * Xfail a test that fails in the C locale.
  * Update and organize depends/recommends.
  * Docs: use a sphinx theme we have, fix spelling,
    link to rather than embed remote resource,
    use https links where available.
  * Stop using deprecated envvar/tag names.
  * Xfail rather than skip previously broken tests,
    and put the condition in the patch not d/rules or d/tests.
  * Remove no longer used patch-stamp.


=== debian/control ===
Source: pandas
Section: python
Priority: optional
Maintainer: Debian Science Team <debian-science-maintainers@lists.alioth.debian.org>
Uploaders: Yaroslav Halchenko <debian@onerussian.com>,
           Michael Hanke <michael.hanke@gmail.com>,
           Rebecca N. Palmer <rebecca_palmer@zoho.com>
Build-Depends: debhelper-compat (= 13),
               dh-python,
               locales-all,
               python3-all-dev,
               cython3 (>= 0.29.13~),
               python3-bottleneck (>= 1.2.1~) <!nocheck> <!nodoc>,
               python3-bs4 <!nocheck> <!nodoc>,
               python3-dask (>= 2.10.1~) <!nocheck> <!nodoc>,
               python3-dateutil,
               python3-html5lib <!nocheck> <!nodoc>,
               python3-hypothesis <!nocheck> <!nodoc>,
               python3-jinja2 <!nocheck> <!nodoc>,
               python3-lxml <!nocheck> <!nodoc>,
               python3-matplotlib [!hurd-i386],
# armel, ppc64el, s390x numba crash, mipsel gives wrong answer, most ports don't have numba
               python3-numba (>= 0.46.0~) [amd64 i386] <!nocheck> <!nodoc>,
               python3-numexpr (>= 2.6.2~) <!nocheck> <!nodoc>,
               python3-numpy,
               python3-odf <!nocheck> <!nodoc>,
               python3-openpyxl <!nocheck> <!nodoc>,
# upstream actually want pytest >= 5.0.1 but we don't have that
               python3-pytest (>= 4.0.2~) <!nocheck> <!nodoc>,
# #969050               python3-pytest-asyncio <!nocheck> <!nodoc>,
               python3-pytest-forked <!nocheck> <!nodoc>,
               python3-pytest-xdist (>= 1.21~) <!nocheck> <!nodoc>,
               python3-scipy,
               python3-setuptools,
               python3-six,
               python3-tables (>= 3.4.2~) <!nocheck> <!nodoc>,
# too old in Debian python3-tabulate (>= 0.8.3~) <!nocheck> <!nodoc>,
               python3-tk <!nocheck> <!nodoc>,
               python3-tz <!nocheck> <!nodoc>,
               python3-xlrd <!nocheck> <!nodoc>,
               python3-xlsxwriter <!nocheck> <!nodoc>,
               python3-xlwt <!nocheck> <!nodoc>,
               xvfb <!nocheck>,
               xauth <!nocheck>,
               xclip <!nocheck>,
Build-Depends-Indep:
 python3-sphinx <!nodoc>,
 python3-ipykernel <!nodoc>,
 python3-nbconvert (>= 5.4.1~) <!nodoc>,
 python3-nbsphinx <!nodoc>,
 python3-numpydoc <!nodoc>,
 ipython3 (>= 7.11.1~) <!nodoc>,
 jdupes <!nodoc>,
# for style.ipynb
 pandoc <!nodoc>,
# for intersphinx inventories
 python3-doc <!nodoc>,
 python-numpy-doc <!nodoc>,
 python-scipy-doc <!nodoc>,
 python-matplotlib-doc <!nodoc>,
 python-statsmodels-doc <!nodoc>,
# these are for not having (as many) exception messages in documentation examples
# so may be temporarily removed if they are broken or to break bootstrap cycles
# not in Debian (not to be confused with python3-arrow) python3-pyarrow <!nodoc>,
 python3-ipywidgets <!nodoc>,
 python3-rpy2 <!nodoc>,
 python3-seaborn <!nodoc>,
 python3-sqlalchemy <!nodoc>,
 python3-statsmodels <!nodoc>,
 python3-xarray <!nodoc>,
Standards-Version: 4.5.0
Rules-Requires-Root: no
Homepage: https://pandas.pydata.org/
Vcs-Browser: https://salsa.debian.org/science-team/pandas
Vcs-Git: https://salsa.debian.org/science-team/pandas.git

Package: python3-pandas
Architecture: all
Depends: ${misc:Depends}, ${python3:Depends},
         python3-numpy (>= 1:1.15~),
         python3-dateutil,
         python3-pandas-lib (>= ${source:Version}),
         python3-pkg-resources,
         python3-six,
Recommends: python3-scipy,
            python3-matplotlib,
            python3-tz,
# for faster processing
# see -lib for python3-numba
            python3-bottleneck,
            python3-numexpr,
# for spreadsheet I/O
            python3-odf,
            python3-openpyxl,
            python3-xlrd,
            python3-xlwt,
# for HTML table I/O
            python3-bs4,
            python3-html5lib,
            python3-lxml,
# for HDF5 I/O
            python3-tables,
# for styled output
            python3-jinja2,
Suggests: python-pandas-doc,
          python3-statsmodels
Breaks:
# 0.23 -> 0.25 API breaks, #931557
        cnvkit (<< 0.9.6-2~),
# 0.25 -> 1.0 API breaks, #950430
        python3-dask (<< 2.10.1~),
        python3-biom-format (<< 2.1.8+dfsg-3.1~),
        python3-feather-format (<< 0.3.1+dfsg1-4~),
        python3-skbio (<< 0.5.5-4~),
        python3-statsmodels (<< 0.11.0~),
        python3-seaborn (<< 0.9.1~),
        q2-demux (<< 2019.10.0-1.1~),
        q2templates (<< 2019.10.0+dfsg-1.1~),
        q2-types (<< 2019.10.0-1.1~)
Description: data structures for "relational" or "labeled" data
 pandas is a Python package providing fast, flexible, and expressive
 data structures designed to make working with "relational" or
 "labeled" data both easy and intuitive. It aims to be the fundamental
 high-level building block for doing practical, real world data
 analysis in Python. pandas is well suited for many different kinds of
 data:
 .
  - Tabular data with heterogeneously-typed columns, as in an SQL
    table or Excel spreadsheet
  - Ordered and unordered (not necessarily fixed-frequency) time
    series data.
  - Arbitrary matrix data (homogeneously typed or heterogeneous) with
    row and column labels
  - Any other form of observational / statistical data sets. The data
    actually need not be labeled at all to be placed into a pandas
    data structure
 .
 This package contains the Python 3 version.

Package: python-pandas-doc
Architecture: all
Section: doc
Depends: ${misc:Depends},
         libjs-jquery,
         libjs-requirejs,
         libjs-underscore,
         libjs-mathjax
Suggests: python3-pandas
Description: data structures for "relational" or "labeled" data - documentation
 pandas is a Python package providing fast, flexible, and expressive
 data structures designed to make working with "relational" or
 "labeled" data both easy and intuitive. It aims to be the fundamental
 high-level building block for doing practical, real world data
 analysis in Python. pandas is well suited for many different kinds of
 data:
 .
  - Tabular data with heterogeneously-typed columns, as in an SQL
    table or Excel spreadsheet
  - Ordered and unordered (not necessarily fixed-frequency) time
    series data.
  - Arbitrary matrix data (homogeneously typed or heterogeneous) with
    row and column labels
  - Any other form of observational / statistical data sets. The data
    actually need not be labeled at all to be placed into a pandas
    data structure
 .
 This package contains the documentation.

Package: python3-pandas-lib
Architecture: any
Multi-Arch: same
Depends: ${misc:Depends}, ${shlibs:Depends}, ${python3:Depends}, python3-numpy (>=1:1.15~)
# this is here to allow it to be arch-specific, to avoid numba bugs on other architectures
Recommends: python3-numba [amd64]
Description: low-level implementations and bindings for pandas
 This is a low-level package for python3-pandas providing
 architecture-dependent extensions.
 .
 Users should not need to install it directly.

=== debian/rules ===
#!/usr/bin/make -f
# -*- mode: makefile; coding: utf-8 -*-

export DEB_BUILD_MAINT_OPTIONS = hardening=+all

# Pass hardening flags into distutils, explicitly
export CFLAGS   = $(shell dpkg-buildflags --get CFLAGS)
export CPPFLAGS = $(shell dpkg-buildflags --get CPPFLAGS)
export CXXFLAGS = $(shell dpkg-buildflags --get CXXFLAGS)

PACKAGE3_NAME = python3-pandas
PACKAGE3_ROOT_DIR = debian/${PACKAGE3_NAME}

PY3VERS = $(shell py3versions -vr)
PY3VER = $(shell py3versions -vd)
SOURCE_DATE:=$(shell date -u -d "@$(SOURCE_DATE_EPOCH)" "+%a, %d %b %Y" || echo "xxx, xx xxx xxxx")
SOURCE_TIME:=$(shell date -u -d "@$(SOURCE_DATE_EPOCH)" "+%T" || echo "xx:xx:xx")

UVER := $(shell LC_ALL=C dpkg-parsechangelog | awk '/^Version:/{print $$2;}' | sed -e 's,-[^-]*$$,,g' | sed -e 's,+dfsg,,g')
# Python doesn't use ~ for rc
UVER_PY := $(shell echo $(UVER) | sed -e 's,[~],,g')
UVER_PYSHORT := $(shell echo $(UVER_PY) | sed -e 's,+git.*,,g')

MIN_CYTHONVER = 0.23

# Filter out tests with "marker expressions" and "keyword expressions". Ref: pytest(1)
ifeq ($(DEB_HOST_ARCH),$(filter $(DEB_HOST_ARCH), amd64 i386 kfreebsd-amd64 kfreebsd-i386 x32))
	PYTEST_MARKER_ARCH :=
else
	PYTEST_MARKER_ARCH := and not slow
endif
PYTEST_MARKER := not network $(PYTEST_MARKER_ARCH)

# try to prevent unsunctioned downloads
export  http_proxy=http://127.0.0.1:9/
export  https_proxy=http://127.0.0.1:9/

export SHELL=/bin/bash

# Mega rule
%:
	: # Explicit build system to avoid use of all-in-1 Makefile
	dh $@ --buildsystem=pybuild --with python3

clean_generated:
	find pandas/ -regex '.*\.c\(\|pp\)' | xargs grep -l -e 'Generated by Cython'  | xargs -r rm -f

_cythonize%:
	debian/rules clean_generated # force removal of previous copies
	python$(*:2=) setup.py cython
	D=debian/cythonized-files$(*:2=) && \
		git rm -rf $$D; \
		find pandas/ -regex '.*\.c\(\|pp\)' | while read f; do \
			grep -q 'Generated by Cython' "$$f" || continue; \
			mkdir -p "$$D/$$(dirname $$f)"; \
			cp "$$f" "$$D/$$(dirname $$f)"; \
			git add -f "$$D/$$f"; \
		done; \
		echo "$(UVER)" >| $$D/VERSION; git add $$D/VERSION

_uncythonize%:
	echo "$*" | grep -q '^3' && PY=3 || PY= ; \
	CYTHONVER=$$(dpkg -l cython$$PY 2>/dev/null | awk '/^ii/{print $$3;}' || echo 0); \
	dpkg --compare-versions "$$CYTHONVER" lt "$(MIN_CYTHONVER)" && { \
		echo "I: Using pre-Cython-ed files for Python $*"; \
		cd debian/cythonized-files$$PY/ ; \
		find . -regex '.*\.c\(\|pp\)' | while read f; do cp $$f ../../$$f; done; } || :

cythonize: _cythonize3

override_dh_clean: clean_generated
	: # Make sure that cythonized sources are up-to-date
	[ ! -e debian/cythonized-files3/VERSION ] || [ "$(UVER)" = "`cat debian/cythonized-files3/VERSION`" ]
	rm -rf build doc/_build *-stamp # pandas.egg-info pandas/datasets/__config__.py
	dh_clean

version_py:
	[ -e pandas/__version.py ] || \
      echo -e "version = '$(UVER_PY)'\nshort_version = '$(UVER_PYSHORT)'" > pandas/__version.py

override_dh_auto_build: version_py
	# Override default build operation which --force's re-cythonization
	# on elderly ubuntus
	# Just build the version.py file
	:


override_dh_auto_install: ${PY3VERS:%=python-install%} ${PY3VERS:%=python-test%}
# Per Python version logic -- install, test, remomove .so (installed into -lib)
python-install%: _uncythonize%
	python$* setup.py install --install-layout=deb --root=$(CURDIR)/debian/tmp

python-test%: python-install%
ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
	echo "backend : Agg" >| $(CURDIR)/build/matplotlibrc
	: # Run unittests here against installed pandas, in sections to avoid out-of-memory crash (#943732); exit code 5 means no tests in this file
	echo "$*" | grep -q '^3' && PY=3 || PY=$*; \
	 export PYTHONPATH=`/bin/ls -d $$PWD/debian/tmp/usr/lib/python$$PY/*/`; \
	 export MPLCONFIGDIR=$(CURDIR)/build HOME=$(CURDIR)/build; \
	 python$* pandas/util/_print_versions.py; \
	 cd build/; TEST_SUCCESS=true; for TEST_SUBSET in $${PYTHONPATH}/pandas/tests/* ; do \
	 LOCALE_OVERRIDE=C xvfb-run -a -s "-screen 0 1280x1024x24 -noreset" \
	 python$* -m pytest -s -v -m "$(PYTEST_MARKER)" --confcutdir=$${PYTHONPATH}/pandas --deb-data-root-dir=$(CURDIR)/pandas/tests --strict-data-files $${TEST_SUBSET} || test $$? == 5 || TEST_SUCCESS=false \
	 ; done ; $${TEST_SUCCESS}
else
	: # Skip unittests due to nocheck
endif

override_dh_installdocs:
	: # Build Documentation using installed pandas
ifeq (,$(filter nodoc,$(DEB_BUILD_OPTIONS)))
ifneq (,$(findstring -a,$(DH_INTERNAL_OPTIONS)))
	: # not building documentation in -a
else
	cd doc && PYTHONPATH=$(CURDIR)/$(PACKAGE3_ROOT_DIR)-lib/usr/lib/python3/dist-packages:$(CURDIR)/$(PACKAGE3_ROOT_DIR)/usr/lib/python3/dist-packages MPLCONFIGDIR=$(CURDIR)/build HOME=$(CURDIR)/build LC_ALL=C python3 make.py html
	# strip build paths and statsmodels timestamps for reproducibility, and online Javascript for privacy
	for html in `find doc/build/html -name _modules -prune -o -name "*.html" -o -name "*.ipynb"` ; do \
	    sed -i -e 's#$(CURDIR)/.pybuild/[^/]*/build/pandas/#/usr/lib/python3/dist-packages/pandas/#g' \
	    -e 's#$(CURDIR)/debian/python3-pandas/usr/lib/python3/dist-packages/pandas/#/usr/lib/python3/dist-packages/pandas/#g' \
	    -e 's#<script crossorigin="anonymous" integrity="sha256-Ae2Vz/4ePdIu6ZyI/5ZGsYnb+m0JlOmKPjt6XZ9JJkA=" type="text/javascript" src="https://cdnjs\.cloudflare\.com/ajax/libs/require\.js/2\.3\.4/require\.min\.js">#<script type="text/javascript" src="file:///usr/share/javascript/requirejs/require.min.js">#g' \
	    -e 's#\(Date:.*\)[A-Z][a-z]\+, \+[0-9]\+,\? \+[A-Z][a-z]\+,\? \+[0-9]\+#\1$(SOURCE_DATE)#g' \
	    -e 's#\(Time:.*\)[0-9][0-9]:[0-9][0-9]:[0-9][0-9]#\1$(SOURCE_TIME)#g' $${html} ; \
	done
	: # Use jquery+underscore from Debian package, so prune shipped one
	rm doc/build/html/_static/jquery.js
	rm doc/build/html/_static/underscore.js
endif
endif
	dh_installdocs -A *.md
	# for NEWS.html.gz - put it here and use symlinks to avoid breaking internal links
	gzip -c -n -9 debian/python-pandas-doc/usr/share/doc/python-pandas-doc/html/whatsnew/index.html > debian/python-pandas-doc/usr/share/doc/python-pandas-doc/html/whatsnew/index.html.gz || true
	cp -av debian/contributors_list.txt debian/python-pandas-doc/usr/share/doc/python-pandas-doc || true
	# deduplicate files - the ||true is because we only build-depend on jdupes if we're building documentation
	jdupes -r -l debian/python-pandas-doc/usr/share/doc || true

override_dh_install:
	dh_install
	find debian -name __pycache__ | xargs rm -rf

## remove .so libraries from main package, and call dh_numpy*
## while removing 2 if not present
_dh_python%:
	[ -e /usr/bin/dh_numpy$(*:2=) ] && dh_numpy$(*:2=) -p$(PACKAGE$*_NAME)-lib || :
	dh_python$*
	-find debian/python*-pandas -name "*.so" -delete

## "Instantiate" both rules so dh sees them
override_dh_python3: _dh_python3

## immediately useable documentation and exemplar scripts/data
override_dh_compress:
	dh_compress -X.py -X.html -X.pdf -X.css -X.jpg -X.txt -X.js -X.json -X.rtc -Xobjects.inv

override_dh_auto_test:
	# do nothing here, we run tests in python-test% instead
	true

=== debian/tests/control ===
# Check that the hard Depends are enough for import
# cd to not-the-source-directory to get the installed pandas
Test-Command: cd "$AUTOPKGTEST_TMP" && python3 -c "import pandas;a=pandas.DataFrame([[1,2],[3,4]])"
Depends: python3-pandas
Restrictions: allow-stderr

# According to pandas/doc/source/install.rst, running the unit tests looks like:
# `py.test-3 --skip-slow --skip-network /usr/lib/python3/dist-packages/pandas/ -v -rs`
# Or simply `python3 -c "import pandas as pd; pd.test()"`, which doesn't require
# us to specify the path (pandas.__path__) in command line.
# See: pandas/util/_tester.py
Tests: unittests3
Depends: locales-all,
         python3-all,
         python3-bs4,
         python3-dask (>= 2.10.1~),
         python3-dateutil,
         python3-html5lib,
         python3-hypothesis,
         python3-jinja2,
         python3-lxml,
         python3-matplotlib [!hurd-i386],
# armel, ppc64el, s390x numba crash, mipsel gives wrong answer, most ports don't have numba
         python3-numba (>= 0.46.0~) [amd64 i386],
         python3-numpy (>= 1:1.15~),
         python3-odf,
         python3-openpyxl,
         python3-pandas,
# upstream actually want pytest >= 5.0.1 but we don't have that
         python3-pytest (>= 4.0.2~),
# #969050         python3-pytest-asyncio,
         python3-pytest-forked,
         python3-pytest-xdist (>= 1.21~),
         python3-scipy,
         python3-six,
         python3-statsmodels,
         python3-tables (>= 3.4.2~),
# too old in Debian python3-tabulate (>= 0.8.3~),
         python3-tk,
         python3-tz,
         python3-xarray,
         python3-xlrd,
         python3-xlsxwriter,
         python3-xlwt,
         xauth,
         xvfb,
         xclip,
Restrictions: allow-stderr

## pandas 1.1.4%2Bdfsg

=== debian/changelog ===
pandas (1.1.4+dfsg-1+rpi1) bullseye-staging; urgency=medium

  * Disable testsuite.

 -- Peter Michael Green <plugwash@raspbian.org>  Thu, 10 Dec 2020 21:10:08 +0000

pandas (1.1.4+dfsg-1) unstable; urgency=medium

  * Upstream bugfix release.  Refresh patches, contributors_list.
  * Remove numba test-depends (skips tests).  (Closes: #973589)
  * Loosen pandas-lib->pandas Depends versioning.  (Closes: #973289)

 -- Rebecca N. Palmer <rebecca_palmer@zoho.com>  Wed, 04 Nov 2020 18:36:11 +0000

pandas (1.1.3+dfsg-2) unstable; urgency=medium

  * Tests: re-xfail an intermittent instance of #877419.
  * Remove no longer needed test_statsmodels xfail.
  * Fix invalid test skips.

 -- Rebecca N. Palmer <rebecca_palmer@zoho.com>  Thu, 22 Oct 2020 07:14:29 +0100

pandas (1.1.3+dfsg-1) unstable; urgency=medium

  * Upstream bugfix release.  Refresh patches, contributors_list.
  * Remove outdated README.source,
    add contributors_list update process.
  * Fix invalid test xfail.
  * Re-add mistakenly removed non-x86 test xfails.
  * Declare transition Breaks (see #969650).
  * Skip another test if multiprocessing is not available.
  * Update cython3 Depends.
  * Fix pytables expression bug with Python 3.9.  (Closes: #972015)
  * Allow test_statsmodels to fail on 3.9 to break bootstrap cycle.
  * Upload to unstable.  (Closes: #969650)

 -- Rebecca N. Palmer <rebecca_palmer@zoho.com>  Sun, 18 Oct 2020 16:22:36 +0100

pandas (1.1.1+dfsg-3) experimental; urgency=medium

  * Remove no longer needed test xfails.
  * Xfail some more non-x86 numba tests and a new instance of #877419.
  * Skip test_register_entrypoint during build.
  * Tests: don't assume little-endian.

 -- Rebecca N. Palmer <rebecca_palmer@zoho.com>  Thu, 03 Sep 2020 08:01:24 +0100

pandas (1.1.1+dfsg-2) experimental; urgency=medium

  * Unconditionally build-depend on sphinx-common (for dh_sphinxdoc).
  * Re-enable but ignore another potentially crashing non-x86 test.

 -- Rebecca N. Palmer <rebecca_palmer@zoho.com>  Tue, 01 Sep 2020 08:17:32 +0100

pandas (1.1.1+dfsg-1) experimental; urgency=medium

  * New upstream release.
  * Upload to experimental.
  * Drop/refresh patches.  Update d/copyright and contributors_list.
  * Re-enable asyncio tests.
  * Skip fsspec tests while it is too old a version.
  * Fix plot test cleanup (upstream bug 35080).
  * Skip test that is expected to fail in our setup.
  * Update minimum dependency versions.
  * Use dh_sphinxdoc.
  * Re-enable but ignore potentially crashing non-x86 tests.
  * Simplify d/rules, mostly by using pybuild more.

 -- Rebecca N. Palmer <rebecca_palmer@zoho.com>  Mon, 31 Aug 2020 18:44:39 +0100

=== debian/rules ===
#!/usr/bin/make -f
# -*- mode: makefile; coding: utf-8 -*-

export DEB_BUILD_MAINT_OPTIONS = hardening=+all
DPKG_EXPORT_BUILDFLAGS = 1
include /usr/share/dpkg/buildflags.mk
include /usr/share/dpkg/pkg-info.mk

PY3VERS := $(shell py3versions -vr)
PY3VER := $(shell py3versions -vd)
SOURCE_DATE:=$(shell date -u -d "@$(SOURCE_DATE_EPOCH)" "+%a, %d %b %Y" || echo "xxx, xx xxx xxxx")
SOURCE_TIME:=$(shell date -u -d "@$(SOURCE_DATE_EPOCH)" "+%T" || echo "xx:xx:xx")

UVER := $(shell echo $(DEB_VERSION_UPSTREAM) | sed -e 's,+dfsg,,g')
# Python doesn't use ~ for rc
UVER_PY := $(shell echo $(UVER) | sed -e 's,[~],,g')
UVER_PYSHORT := $(shell echo $(UVER_PY) | sed -e 's,+git.*,,g')

# Filter out tests with "marker expressions" and "keyword expressions". Ref: pytest(1)
ifeq ($(DEB_HOST_ARCH),$(filter $(DEB_HOST_ARCH), amd64 i386 kfreebsd-amd64 kfreebsd-i386 x32))
	PYTEST_MARKER := not network
else
	PYTEST_MARKER := not network and not slow
endif
# for matplotlib etc
export HOME=$(CURDIR)/buildtmp

# Split up the test suite to avoid running out of memory, use xvfb for plot tests, run but ignore potentially crashing tests; test_register_entrypoint expects an installed package
export PYBUILD_TEST_ARGS=TEST_SUCCESS=true; cd {build_dir} ; for TEST_SUBSET in {build_dir}/pandas/tests/* ; do LOCALE_OVERRIDE=C xvfb-run -a -s "-screen 0 1280x1024x24 -noreset" {interpreter} -m pytest -s -v -m "$(PYTEST_MARKER)" -k "not test_register_entrypoint" --confcutdir={build_dir}/pandas --deb-data-root-dir={dir}/pandas/tests --strict-data-files $$TEST_SUBSET || test $$? = 5 || TEST_SUCCESS=false ; done ; LOCALE_OVERRIDE=C {interpreter} -m pytest -s -v -m "$(PYTEST_MARKER)" --forked --runxfail --confcutdir={build_dir}/pandas --deb-data-root-dir={dir}/pandas/tests --strict-data-files {build_dir}/pandas/tests/groupby/transform/test_numba.py {build_dir}/pandas/tests/window/test_numba.py {build_dir}/pandas/tests/window/test_apply.py || true ; $$TEST_SUCCESS

export PYBUILD_EXT_DESTDIR=debian/python3-pandas-lib
export PYBUILD_DESTDIR=debian/python3-pandas

# try to prevent unsanctioned downloads
export  http_proxy=http://127.0.0.1:9/
export  https_proxy=http://127.0.0.1:9/

export SHELL=/bin/bash

# Mega rule
%:
	: # Explicit build system to avoid use of all-in-1 Makefile
	dh $@ --buildsystem=pybuild --with python3,numpy3,sphinxdoc

# The *cython* rules are provided to allow using pre-built Cython files in distributions without a new enough Cython; they are not (and must not be) used in official Debian builds (including -backports).  Use instructions:
# on a system with new enough Cython, run debian/rules cythonize - this will add a directory under debian/
# uncomment the _uncythonize rule dependency below
# remove the cython3 Build-Depends from d/control
# copy to the older system and build as normal
# To upgrade to a new upstream version, this process must be repeated
# Warning - has not been tested for some time
_cythonize%: override_dh_clean # force removal of previous copies
	python$(*:2=) setup.py cython
	D=debian/cythonized-files$(*:2=) && \
		git rm -rf $$D || rm -rf $$D; \
		find pandas/ -regex '.*\.c\(\|pp\)' | while read f; do \
			grep -q 'Generated by Cython' "$$f" || continue; \
			mkdir -p "$$D/$$(dirname $$f)"; \
			cp "$$f" "$$D/$$(dirname $$f)"; \
			git add -f "$$D/$$f" || true; \
		done; \
		echo "$(UVER)" >| $$D/VERSION; git add $$D/VERSION || true

_uncythonize%:
	: # Make sure that cythonized sources are up-to-date
	[ "$(UVER)" = "`cat debian/cythonized-files3/VERSION`" ]
	echo "$*" | grep -q '^3' && PY=3 || PY= ; \
		echo "I: Using pre-Cython-ed files for Python $*"; \
		cd debian/cythonized-files$$PY/ ; \
		find . -regex '.*\.c\(\|pp\)' | while read f; do cp $$f ../../$$f; done

cythonize: _cythonize3

override_dh_clean:
	find pandas/ -regex '.*\.c\(\|pp\)' | xargs grep -l -e 'Generated by Cython'  | xargs -r rm -f
	rm -rf build buildtmp doc/build *-stamp # pandas.egg-info pandas/datasets/__config__.py
	dh_clean

override_dh_auto_build-arch: # ${PY3VERS:%=_uncythonize%}
	mkdir -p buildtmp
	[ -e pandas/__version.py ] || \
	echo -e "version = '$(UVER_PY)'\nshort_version = '$(UVER_PYSHORT)'" > pandas/__version.py
	dh_auto_build

override_dh_auto_build-indep: override_dh_auto_build-arch
ifeq (,$(filter nodoc,$(DEB_BUILD_OPTIONS)))
	: # Build Documentation
	cd doc && PYTHONPATH=$(CURDIR)/.pybuild/cpython3_$(PY3VER)/build LC_ALL=C python3 make.py html
	# strip build paths and statsmodels timestamps for reproducibility, and online Javascript for privacy
	for html in `find doc/build/html -name _modules -prune -o -name "*.html" -o -name "*.ipynb"` ; do \
	    sed -i -e 's#$(CURDIR)/.pybuild/[^/]*/build/pandas/#/usr/lib/python3/dist-packages/pandas/#g' \
	    -e 's#$(CURDIR)/debian/python3-pandas/usr/lib/python3/dist-packages/pandas/#/usr/lib/python3/dist-packages/pandas/#g' \
	    -e 's#<script crossorigin="anonymous" integrity="sha256-Ae2Vz/4ePdIu6ZyI/5ZGsYnb+m0JlOmKPjt6XZ9JJkA=" type="text/javascript" src="https://cdnjs\.cloudflare\.com/ajax/libs/require\.js/2\.3\.4/require\.min\.js">#<script type="text/javascript" src="file:///usr/share/javascript/requirejs/require.min.js">#g' \
	    -e 's#\(Date:.*\)[A-Z][a-z]\+, \+[0-9]\+,\? \+[A-Z][a-z]\+,\? \+[0-9]\+#\1$(SOURCE_DATE)#g' \
	    -e 's#\(Time:.*\)[0-9][0-9]:[0-9][0-9]:[0-9][0-9]#\1$(SOURCE_TIME)#g' $${html} ; \
	done
endif

override_dh_installdocs:
	dh_installdocs -A *.md
	# for NEWS.html.gz - put it here and use symlinks to avoid breaking internal links
	gzip -c -n -9 debian/python-pandas-doc/usr/share/doc/python-pandas-doc/html/whatsnew/index.html > debian/python-pandas-doc/usr/share/doc/python-pandas-doc/html/whatsnew/index.html.gz || true
	cp -av debian/contributors_list.txt debian/python-pandas-doc/usr/share/doc/python-pandas-doc || true
	# deduplicate files - the ||true is because we only build-depend on jdupes if we're building documentation
	jdupes -r -l debian/python-pandas-doc/usr/share/doc || true


## immediately useable documentation and exemplar scripts/data
override_dh_compress:
	dh_compress -X.py -X.html -X.pdf -X.css -X.jpg -X.txt -X.js -X.json -X.rtc -Xobjects.inv

# see PYBUILD_TEST_ARGS above
override_dh_auto_test:
	#PYBUILD_SYSTEM=custom dh_auto_test

## pandas 1.1.4+dfsg

=== debian/control ===
--- 
+++ 
@@ -9,37 +9,38 @@
                dh-python,
                locales-all,
                python3-all-dev,
-               cython3 (>= 0.29.13~),
+               cython3 (>= 0.29.21~),
                python3-bottleneck (>= 1.2.1~) <!nocheck> <!nodoc>,
                python3-bs4 <!nocheck> <!nodoc>,
                python3-dask (>= 2.10.1~) <!nocheck> <!nodoc>,
-               python3-dateutil,
+               python3-dateutil (>= 2.7.3~),
                python3-html5lib <!nocheck> <!nodoc>,
                python3-hypothesis <!nocheck> <!nodoc>,
                python3-jinja2 <!nocheck> <!nodoc>,
                python3-lxml <!nocheck> <!nodoc>,
                python3-matplotlib [!hurd-i386],
-# armel, ppc64el, s390x numba crash, mipsel gives wrong answer, most ports don't have numba
-               python3-numba (>= 0.46.0~) [amd64 i386] <!nocheck> <!nodoc>,
+# armel, s390x numba crash, mipsel gives wrong answer, most ports don't have numba
+# re-add when #972246 is fixed               python3-numba (>= 0.46.0~) [amd64 arm64 armhf i386 mips64el mipsel ppc64el s390x] <!nocheck> <!nodoc>,
                python3-numexpr (>= 2.6.2~) <!nocheck> <!nodoc>,
                python3-numpy,
                python3-odf <!nocheck> <!nodoc>,
                python3-openpyxl <!nocheck> <!nodoc>,
 # upstream actually want pytest >= 5.0.1 but we don't have that
                python3-pytest (>= 4.0.2~) <!nocheck> <!nodoc>,
-# #969050               python3-pytest-asyncio <!nocheck> <!nodoc>,
+               python3-pytest-asyncio <!nocheck> <!nodoc>,
                python3-pytest-forked <!nocheck> <!nodoc>,
                python3-pytest-xdist (>= 1.21~) <!nocheck> <!nodoc>,
                python3-scipy,
                python3-setuptools,
                python3-six,
-               python3-tables (>= 3.4.2~) <!nocheck> <!nodoc>,
+               python3-tables (>= 3.4.3~) <!nocheck> <!nodoc>,
 # too old in Debian python3-tabulate (>= 0.8.3~) <!nocheck> <!nodoc>,
                python3-tk <!nocheck> <!nodoc>,
                python3-tz <!nocheck> <!nodoc>,
                python3-xlrd <!nocheck> <!nodoc>,
                python3-xlsxwriter <!nocheck> <!nodoc>,
                python3-xlwt <!nocheck> <!nodoc>,
+               sphinx-common,
                xvfb <!nocheck>,
                xauth <!nocheck>,
                xclip <!nocheck>,
@@ -78,8 +79,9 @@
 Architecture: all
 Depends: ${misc:Depends}, ${python3:Depends},
          python3-numpy (>= 1:1.15~),
-         python3-dateutil,
-         python3-pandas-lib (>= ${source:Version}),
+         python3-dateutil (>= 2.7.3~),
+         python3-pandas-lib (>= ${source:Upstream-Version}),
+# should maybe have a python3-pandas-lib (<< ${source:Upstream-Version}.0), as well, but that leaves arch:all BD-Uninstallable if arch:amd64 builds first
          python3-pkg-resources,
          python3-six,
 Recommends: python3-scipy,
@@ -108,15 +110,16 @@
 # 0.23 -> 0.25 API breaks, #931557
         cnvkit (<< 0.9.6-2~),
 # 0.25 -> 1.0 API breaks, #950430
-        python3-dask (<< 2.10.1~),
         python3-biom-format (<< 2.1.8+dfsg-3.1~),
         python3-feather-format (<< 0.3.1+dfsg1-4~),
-        python3-skbio (<< 0.5.5-4~),
         python3-statsmodels (<< 0.11.0~),
         python3-seaborn (<< 0.9.1~),
         q2-demux (<< 2019.10.0-1.1~),
         q2templates (<< 2019.10.0+dfsg-1.1~),
-        q2-types (<< 2019.10.0-1.1~)
+        q2-types (<< 2019.10.0-1.1~),
+# 1.0 -> 1.1 API breaks, #969650
+        python3-dask (<< 2.11.0+dfsg-1.1~),
+        python3-skbio (<< 0.5.6-3~)
 Description: data structures for "relational" or "labeled" data
  pandas is a Python package providing fast, flexible, and expressive
  data structures designed to make working with "relational" or
@@ -141,10 +144,7 @@
 Architecture: all
 Section: doc
 Depends: ${misc:Depends},
-         libjs-jquery,
-         libjs-requirejs,
-         libjs-underscore,
-         libjs-mathjax
+         ${sphinxdoc:Depends}
 Suggests: python3-pandas
 Description: data structures for "relational" or "labeled" data - documentation
  pandas is a Python package providing fast, flexible, and expressive

=== debian/tests/control ===
--- 
+++ 
@@ -14,27 +14,27 @@
          python3-all,
          python3-bs4,
          python3-dask (>= 2.10.1~),
-         python3-dateutil,
+         python3-dateutil (>= 2.7.3~),
          python3-html5lib,
          python3-hypothesis,
          python3-jinja2,
          python3-lxml,
          python3-matplotlib [!hurd-i386],
-# armel, ppc64el, s390x numba crash, mipsel gives wrong answer, most ports don't have numba
-         python3-numba (>= 0.46.0~) [amd64 i386],
+# armel, s390x numba crash, mipsel gives wrong answer, most ports don't have numba
+# re-add when #972246 is fixed         python3-numba (>= 0.46.0~) [amd64 arm64 armhf i386 mips64el mipsel ppc64el s390x],
          python3-numpy (>= 1:1.15~),
          python3-odf,
          python3-openpyxl,
          python3-pandas,
 # upstream actually want pytest >= 5.0.1 but we don't have that
          python3-pytest (>= 4.0.2~),
-# #969050         python3-pytest-asyncio,
+         python3-pytest-asyncio,
          python3-pytest-forked,
          python3-pytest-xdist (>= 1.21~),
          python3-scipy,
          python3-six,
          python3-statsmodels,
-         python3-tables (>= 3.4.2~),
+         python3-tables (>= 3.4.3~),
 # too old in Debian python3-tabulate (>= 0.8.3~),
          python3-tk,
          python3-tz,

## pandas 1.1.5+dfsg

=== Makefile ===
.PHONY : develop build clean clean_pyc doc lint-diff black

all: develop

clean:
	-python setup.py clean

clean_pyc:
	-find . -name '*.py[co]' -exec rm {} \;

build: clean_pyc
	python setup.py build_ext --inplace

lint-diff:
	git diff upstream/master --name-only -- "*.py" | xargs flake8

black:
	black .

develop: build
	python -m pip install --no-build-isolation -e .

doc:
	-rm -rf doc/build doc/source/generated
	cd doc; \
	python make.py clean; \
	python make.py html

=== debian/changelog ===
pandas (1.1.5+dfsg-2) unstable; urgency=medium

  * Remove dead URL from tests/examples.  (Closes: #979621)
  * Mark autopkgtest needs-internet.
  * Revert "Print uname etc during build".
  * Mark matplotlib nocheck/nodoc and allow building on ports without
    matplotlib or numexpr.  (Closes: #977470)
  * Add python3-tabulate build/test-depends.
  * Add bottleneck and numexpr test-depends.
  * Tests: don't require warnings that jedi no longer produces.

 -- Rebecca N. Palmer <rebecca_palmer@zoho.com>  Tue, 12 Jan 2021 21:06:04 +0000

pandas (1.1.5+dfsg-1) unstable; urgency=medium

  * Upstream bugfix release.  Refresh patches, contributors_list.
  * Default to openpyxl not xlrd in read_excel, and skip xlrd tests,
    as xlrd fails if defusedxml is installed (#976620).
  * Skip numba tests, and not other rolling.apply tests, on s390x.
    (LP: #1901860)
  * Tests: on 32 bit systems, avoid time input that overflows.
  * Print uname etc during build (test for #973854).
  * Bump Standards-Version to 4.5.1 (no changes needed).

 -- Rebecca N. Palmer <rebecca_palmer@zoho.com>  Mon, 07 Dec 2020 23:06:28 +0000

=== debian/control ===
--- 
+++ 
@@ -18,14 +18,14 @@
                python3-hypothesis <!nocheck> <!nodoc>,
                python3-jinja2 <!nocheck> <!nodoc>,
                python3-lxml <!nocheck> <!nodoc>,
-               python3-matplotlib [!hurd-i386],
+               python3-matplotlib [!ia64 !sh4 !x32] <!nocheck> <!nodoc>,
 # armel, s390x numba crash, mipsel gives wrong answer, most ports don't have numba
 # re-add when #972246 is fixed               python3-numba (>= 0.46.0~) [amd64 arm64 armhf i386 mips64el mipsel ppc64el s390x] <!nocheck> <!nodoc>,
-               python3-numexpr (>= 2.6.2~) <!nocheck> <!nodoc>,
+               python3-numexpr (>= 2.6.2~) [!kfreebsd-any !sparc64] <!nocheck> <!nodoc>,
                python3-numpy,
                python3-odf <!nocheck> <!nodoc>,
                python3-openpyxl <!nocheck> <!nodoc>,
-# upstream actually want pytest >= 5.0.1 but we don't have that
+# upstream actually want pytest >= 5.0.1 but we don't have that in testing
                python3-pytest (>= 4.0.2~) <!nocheck> <!nodoc>,
                python3-pytest-asyncio <!nocheck> <!nodoc>,
                python3-pytest-forked <!nocheck> <!nodoc>,
@@ -34,10 +34,10 @@
                python3-setuptools,
                python3-six,
                python3-tables (>= 3.4.3~) <!nocheck> <!nodoc>,
-# too old in Debian python3-tabulate (>= 0.8.3~) <!nocheck> <!nodoc>,
+               python3-tabulate (>= 0.8.3~) <!nocheck> <!nodoc>,
                python3-tk <!nocheck> <!nodoc>,
                python3-tz <!nocheck> <!nodoc>,
-               python3-xlrd <!nocheck> <!nodoc>,
+# broken - #976620               python3-xlrd <!nocheck> <!nodoc>,
                python3-xlsxwriter <!nocheck> <!nodoc>,
                python3-xlwt <!nocheck> <!nodoc>,
                sphinx-common,
@@ -69,7 +69,7 @@
  python3-sqlalchemy <!nodoc>,
  python3-statsmodels <!nodoc>,
  python3-xarray <!nodoc>,
-Standards-Version: 4.5.0
+Standards-Version: 4.5.1
 Rules-Requires-Root: no
 Homepage: https://pandas.pydata.org/
 Vcs-Browser: https://salsa.debian.org/science-team/pandas
@@ -94,7 +94,7 @@
 # for spreadsheet I/O
             python3-odf,
             python3-openpyxl,
-            python3-xlrd,
+# broken - #976620            python3-xlrd,
             python3-xlwt,
 # for HTML table I/O
             python3-bs4,

=== debian/rules ===
--- 
+++ 
@@ -111,4 +111,4 @@
 
 # see PYBUILD_TEST_ARGS above
 override_dh_auto_test:
-	#PYBUILD_SYSTEM=custom dh_auto_test
+	PYBUILD_SYSTEM=custom dh_auto_test

=== debian/tests/control ===
--- 
+++ 
@@ -12,6 +12,7 @@
 Tests: unittests3
 Depends: locales-all,
          python3-all,
+         python3-bottleneck (>= 1.2.1~),
          python3-bs4,
          python3-dask (>= 2.10.1~),
          python3-dateutil (>= 2.7.3~),
@@ -22,11 +23,12 @@
          python3-matplotlib [!hurd-i386],
 # armel, s390x numba crash, mipsel gives wrong answer, most ports don't have numba
 # re-add when #972246 is fixed         python3-numba (>= 0.46.0~) [amd64 arm64 armhf i386 mips64el mipsel ppc64el s390x],
+         python3-numexpr (>= 2.6.2~),
          python3-numpy (>= 1:1.15~),
          python3-odf,
          python3-openpyxl,
          python3-pandas,
-# upstream actually want pytest >= 5.0.1 but we don't have that
+# upstream actually want pytest >= 5.0.1 but we don't have that in testing
          python3-pytest (>= 4.0.2~),
          python3-pytest-asyncio,
          python3-pytest-forked,
@@ -35,14 +37,14 @@
          python3-six,
          python3-statsmodels,
          python3-tables (>= 3.4.3~),
-# too old in Debian python3-tabulate (>= 0.8.3~),
+         python3-tabulate (>= 0.8.3~),
          python3-tk,
          python3-tz,
          python3-xarray,
-         python3-xlrd,
+# broken - #976620         python3-xlrd,
          python3-xlsxwriter,
          python3-xlwt,
          xauth,
          xvfb,
          xclip,
-Restrictions: allow-stderr
+Restrictions: allow-stderr, needs-internet

=== debian/watch ===
version=4
opts="dversionmangle=s/.dfsg[0-9]*$//,uversionmangle=s/v//;s/rc/~rc/,filenamemangle=s/.*\/(.*)/pandas-$1\.tar\.gz/,repacksuffix=+dfsg" \
 https://github.com/pydata/pandas/tags .*archive/v?([\d\.rc]+).tar.gz

## pandas 1.3.5%2Bdfsg

=== debian/rules ===
--- 
+++ 
@@ -25,8 +25,8 @@
 # for matplotlib etc
 export HOME=$(CURDIR)/buildtmp
 
-# Split up the test suite to avoid running out of memory, use xvfb for plot tests, run but ignore potentially crashing tests; test_register_entrypoint expects an installed package
-export PYBUILD_TEST_ARGS=TEST_SUCCESS=true; cd {build_dir} ; for TEST_SUBSET in {build_dir}/pandas/tests/* ; do LOCALE_OVERRIDE=C xvfb-run -a -s "-screen 0 1280x1024x24 -noreset" {interpreter} -m pytest -s -v -m "$(PYTEST_MARKER)" -k "not test_register_entrypoint" --confcutdir={build_dir}/pandas --deb-data-root-dir={dir}/pandas/tests --strict-data-files $$TEST_SUBSET || test $$? = 5 || TEST_SUCCESS=false ; done ; LOCALE_OVERRIDE=C {interpreter} -m pytest -s -v -m "$(PYTEST_MARKER)" --forked --runxfail --confcutdir={build_dir}/pandas --deb-data-root-dir={dir}/pandas/tests --strict-data-files {build_dir}/pandas/tests/groupby/transform/test_numba.py {build_dir}/pandas/tests/window/test_numba.py {build_dir}/pandas/tests/window/test_apply.py || true ; $$TEST_SUCCESS
+# Split up the test suite to avoid running out of memory, use xvfb for plot tests, run but ignore potentially crashing tests; test_register_entrypoint expects an installed package, test_wrong_url needs internet, test_statsmodels is a circular dependency when adding a new Python version
+export PYBUILD_TEST_ARGS=TEST_SUCCESS=true; cd {build_dir} ; for TEST_SUBSET in {build_dir}/pandas/tests/* ; do LOCALE_OVERRIDE=C xvfb-run -a -s "-screen 0 1280x1024x24 -noreset" {interpreter} -m pytest -s -v -m "$(PYTEST_MARKER)" -k "not test_register_entrypoint and not test_wrong_url and not test_statsmodels" --confcutdir={build_dir}/pandas --deb-data-root-dir={dir}/pandas/tests --strict-data-files $$TEST_SUBSET || test $$? = 5 || TEST_SUCCESS=false ; done ; LOCALE_OVERRIDE=C {interpreter} -m pytest -s -v -m "$(PYTEST_MARKER)" --forked --runxfail --confcutdir={build_dir}/pandas --deb-data-root-dir={dir}/pandas/tests --strict-data-files {build_dir}/pandas/tests/groupby/transform/test_numba.py {build_dir}/pandas/tests/groupby/aggregate/test_numba.py {build_dir}/pandas/tests/window/test_numba.py {build_dir}/pandas/tests/window/test_apply.py {build_dir}/pandas/tests/window/test_online.py {build_dir}/pandas/tests/window/moments/test_moments_consistency_expanding.py || true ; rm -f test-data.xml ; $$TEST_SUCCESS
 
 export PYBUILD_EXT_DESTDIR=debian/python3-pandas-lib
 export PYBUILD_DESTDIR=debian/python3-pandas
@@ -90,7 +90,6 @@
 	for html in `find doc/build/html -name _modules -prune -o -name "*.html" -o -name "*.ipynb"` ; do \
 	    sed -i -e 's#$(CURDIR)/.pybuild/[^/]*/build/pandas/#/usr/lib/python3/dist-packages/pandas/#g' \
 	    -e 's#$(CURDIR)/debian/python3-pandas/usr/lib/python3/dist-packages/pandas/#/usr/lib/python3/dist-packages/pandas/#g' \
-	    -e 's#<script crossorigin="anonymous" integrity="sha256-Ae2Vz/4ePdIu6ZyI/5ZGsYnb+m0JlOmKPjt6XZ9JJkA=" type="text/javascript" src="https://cdnjs\.cloudflare\.com/ajax/libs/require\.js/2\.3\.4/require\.min\.js">#<script type="text/javascript" src="file:///usr/share/javascript/requirejs/require.min.js">#g' \
 	    -e 's#\(Date:.*\)[A-Z][a-z]\+, \+[0-9]\+,\? \+[A-Z][a-z]\+,\? \+[0-9]\+#\1$(SOURCE_DATE)#g' \
 	    -e 's#\(Time:.*\)[0-9][0-9]:[0-9][0-9]:[0-9][0-9]#\1$(SOURCE_TIME)#g' $${html} ; \
 	done
@@ -111,4 +110,6 @@
 
 # see PYBUILD_TEST_ARGS above
 override_dh_auto_test:
-	PYBUILD_SYSTEM=custom dh_auto_test
+ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
+	PYBUILD_SYSTEM=custom dh_auto_test || [ `dpkg --print-architecture` = mips64el ] || [ `dpkg --print-architecture` = mipsel ]
+endif

=== debian/tests/control ===
--- 
+++ 
@@ -10,7 +10,9 @@
 # us to specify the path (pandas.__path__) in command line.
 # See: pandas/util/_tester.py
 Tests: unittests3
-Depends: locales-all,
+# xml test_wrong_url fails without ca-certificates
+Depends: ca-certificates,
+         locales-all,
          python3-all,
          python3-bottleneck (>= 1.2.1~),
          python3-bs4,
@@ -22,14 +24,13 @@
          python3-lxml,
          python3-matplotlib [!hurd-i386],
 # armel, s390x numba crash, mipsel gives wrong answer, most ports don't have numba
-# re-add when #972246 is fixed         python3-numba (>= 0.46.0~) [amd64 arm64 armhf i386 mips64el mipsel ppc64el s390x],
-         python3-numexpr (>= 2.6.2~),
+         python3-numba (>= 0.46.0~) [amd64 arm64 armhf i386 mips64el mipsel ppc64el s390x],
+         python3-numexpr (>= 2.7~),
          python3-numpy (>= 1:1.15~),
          python3-odf,
          python3-openpyxl,
          python3-pandas,
-# upstream actually want pytest >= 5.0.1 but we don't have that in testing
-         python3-pytest (>= 4.0.2~),
+         python3-pytest (>= 6.0~),
          python3-pytest-asyncio,
          python3-pytest-forked,
          python3-pytest-xdist (>= 1.21~),
@@ -41,7 +42,7 @@
          python3-tk,
          python3-tz,
          python3-xarray,
-# broken - #976620         python3-xlrd,
+         python3-xlrd,
          python3-xlsxwriter,
          python3-xlwt,
          xauth,
